## dssp 4.5.5

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.23)

# set the project name
project(mkdssp VERSION 4.5.5 LANGUAGES CXX)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(CPM)
include(CTest)
include(VersionString)

# The default build type must be set before project()
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR AND NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type" FORCE)
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers")
elseif(MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

# Optionally build a version to be installed inside CCP4
option(BUILD_FOR_CCP4 "Build a version to be installed in CCP4" OFF)
option(BUILD_DOCUMENTATION "Generate the documentation files using pandoc" OFF)
option(BUILD_PYTHON_MODULE "Build an experimental Python module" OFF)
option(INSTALL_LIBRARY "Install the libdssp library" OFF)

if(BUILD_FOR_CCP4)
	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
		message(FATAL_ERROR "dssp: A CCP4 built was requested but CCP4 was not sourced")
	else()
		list(APPEND CMAKE_MODULE_PATH "$ENV{CCP4}")
		list(APPEND CMAKE_PREFIX_PATH "$ENV{CCP4}")
		set(CMAKE_INSTALL_PREFIX "$ENV{CCP4}")

		if(WIN32)
			set(BUILD_SHARED_LIBS ON)
		endif()
	endif()
endif()

if(WIN32)
	if(${CMAKE_SYSTEM_VERSION} GREATER_EQUAL 10) # Windows 10
		add_definitions(-D _WIN32_WINNT=0x0A00)
	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.3) # Windows 8.1
		add_definitions(-D _WIN32_WINNT=0x0603)
	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.2) # Windows 8
		add_definitions(-D _WIN32_WINNT=0x0602)
	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.1) # Windows 7
		add_definitions(-D _WIN32_WINNT=0x0601)
	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.0) # Windows Vista
		add_definitions(-D _WIN32_WINNT=0x0600)
	else() # Windows XP (5.1)
		add_definitions(-D _WIN32_WINNT=0x0501)
	endif()

	# Man, this is 2024 we're living in...
	add_definitions(-DNOMINMAX)

	# We do not want to write an export file for all our symbols...
	set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

if(MSVC)
	# make msvc standards compliant...
	add_compile_options(/permissive- /bigobj)
	add_link_options(/NODEFAULTLIB:library)

	# This is dubious...
	if(BUILD_SHARED_LIBS)
		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
	else()
		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
	endif()
endif()

# Create a revision file, containing the current git version info
write_version_header("${CMAKE_CURRENT_SOURCE_DIR}/src")

# Optionally use mrc to create resources
find_package(mrc QUIET)

if(MRC_FOUND)
	option(USE_RSRC "Use mrc to create resources" ON)
else()
	message(STATUS "dssp: Not using resources since mrc was not found")
endif()

set(CMAKE_THREAD_PREFER_PTHREAD)
set(THREADS_PREFER_PTHREAD_FLAG)
find_package(Threads)

CPMFindPackage(
	NAME mcfp
	GIT_REPOSITORY https://github.com/mhekkel/libmcfp
	GIT_TAG v1.4.2
	EXCLUDE_FROM_ALL YES)

# CPMFindPackage does not pass on variables set with set_and_check
# Working around this here
find_package(cifpp 8.0.1 QUIET)

if(NOT cifpp_FOUND)
	CPMAddPackage(
		NAME cifpp
		GIT_REPOSITORY https://github.com/pdb-redo/libcifpp.git
		GIT_TAG v8.0.1
		EXCLUDE_FROM_ALL YES)
endif()

if(TARGET cifpp)
	get_target_property(CIFPP_SOURCE_DIR cifpp SOURCE_DIR)
	set(CIFPP_SHARE_DIR share/libcifpp)
	set(CIFPP_DATA_DIR ${CIFPP_SOURCE_DIR}/rsrc)
elseif(DEFINED CIFPP_SHARE_DIR)
	set(CIFPP_DATA_DIR ${CIFPP_SHARE_DIR})
else()
	message(FATAL_ERROR "dssp: The CIFPP_SHARE_DIR variable is not found in the cifpp configuration files")
endif()

if(INSTALL_LIBRARY)
	add_subdirectory(libdssp)
else()
	add_subdirectory(libdssp EXCLUDE_FROM_ALL)
endif()

add_executable(mkdssp ${CMAKE_CURRENT_SOURCE_DIR}/src/mkdssp.cpp)

target_link_libraries(mkdssp PRIVATE mcfp::mcfp dssp::dssp)

if(USE_RSRC)
	mrc_target_resources(mkdssp
		${CIFPP_DATA_DIR}/mmcif_pdbx.dic
		${CMAKE_CURRENT_SOURCE_DIR}/libdssp/mmcif_pdbx/dssp-extension.dic)
else()
	get_target_property(LIBDSSP_SOURCE_DIR dssp SOURCE_DIR)

	install(FILES
		${CMAKE_CURRENT_SOURCE_DIR}/libdssp/mmcif_pdbx/dssp-extension.dic
		DESTINATION ${CIFPP_SHARE_DIR})

	if(TARGET cifpp)
		install(FILES ${CIFPP_DATA_DIR}/mmcif_pdbx.dic
			DESTINATION ${CIFPP_SHARE_DIR})
	endif()
endif()

# Install rules
install(TARGETS ${PROJECT_NAME}
	RUNTIME DESTINATION bin
)

if(BUILD_DOCUMENTATION)
	add_subdirectory(doc)
endif()

if(UNIX)
	install(FILES doc/mkdssp.1
		DESTINATION share/man/man1)
endif()

if(EXISTS "${CCP4}/html")
	install(FILES doc/mkdssp.html
		DESTINATION ${CCP4}/html)
endif()

# test
if(BUILD_TESTING AND PROJECT_IS_TOP_LEVEL)
	add_subdirectory(test)
endif()

# Python
if(BUILD_PYTHON_MODULE)
	add_subdirectory(python-module)
endif()

include(InstallRequiredSystemLibraries)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")

# Tarball generation
set(CPACK_SOURCE_TGZ ON)
set(CPACK_SOURCE_TBZ2 OFF)
set(CPACK_SOURCE_TXZ OFF)
set(CPACK_SOURCE_TZ OFF)
set(CPACK_SOURCE_IGNORE_FILES "/data/components.cif;/build;/.vscode;/.git")
set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_FILE_NAME})

# NSIS options
set(CPACK_NSIS_MODIFY_PATH ON)

# configuration done, include CPack
include(CPack)

=== libdssp/CMakeLists.txt ===
# Use the version of the parent list file, if any. May need a fix someday.
if(NOT CMAKE_PARENT_LIST_FILE)
	set(PROJECT_VERSION 4.5.2)
endif()

project(libdssp VERSION ${PROJECT_VERSION})

include(CMakePackageConfigHelpers)

# We do not want to write an export file for all our symbols...
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

# Create a revision file, containing the current git version info
write_version_header("${CMAKE_CURRENT_SOURCE_DIR}/src" LIB_NAME libdssp)

# The DSSP code is in a separate library, optionally to be used by others
add_library(dssp)
add_library(dssp::dssp ALIAS dssp)

target_sources(dssp
	PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}/src/dssp.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/dssp-io.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/dssp-io.hpp
	PUBLIC
	FILE_SET dssp_header TYPE HEADERS
	BASE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include
	FILES include/dssp.hpp
)

target_link_libraries(dssp PUBLIC cifpp::cifpp)

set_target_properties(dssp PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(dssp PUBLIC cxx_std_17)

target_include_directories(dssp
	PUBLIC
	"$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include;${CMAKE_CURRENT_SOURCE_DIR}/../src>"
	"$<INSTALL_INTERFACE:include>"
)

# Install rules
install(TARGETS dssp
	EXPORT dssp
	FILE_SET dssp_header DESTINATION include)

if(MSVC AND BUILD_SHARED_LIBS)
	install(
		FILES $<TARGET_PDB_FILE:dssp>
		DESTINATION "lib"
		OPTIONAL)
endif()

install(EXPORT dssp
	FILE "dssp-targets.cmake"
	NAMESPACE dssp::
	DESTINATION lib/cmake/dssp
)

set(CONFIG_TEMPLATE_FILE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/dssp-config.cmake.in)

configure_package_config_file(
	${CONFIG_TEMPLATE_FILE}
	${CMAKE_CURRENT_BINARY_DIR}/dssp/dssp-config.cmake
	INSTALL_DESTINATION lib/cmake/dssp
)

set(dssp_MAJOR_VERSION ${CMAKE_PROJECT_VERSION_MAJOR})
set_target_properties(dssp PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${dssp_MAJOR_VERSION}
	INTERFACE_dssp_MAJOR_VERSION ${dssp_MAJOR_VERSION})

set_property(TARGET dssp APPEND PROPERTY
	COMPATIBLE_INTERFACE_STRING dssp_MAJOR_VERSION
)

write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/dssp/dssp-config-version.cmake"
	VERSION ${PROJECT_VERSION}
	COMPATIBILITY AnyNewerVersion
)

install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/dssp/dssp-config.cmake"
	"${CMAKE_CURRENT_BINARY_DIR}/dssp/dssp-config-version.cmake"
	DESTINATION lib/cmake/dssp
	COMPONENT Devel
)


# set(CIFPP_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/libcifpp")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/mmcif_pdbx/dssp-extension.dic"
        DESTINATION share/libcifpp)

=== test/CMakeLists.txt ===
CPMFindPackage(
	NAME Catch2 3
	GIT_REPOSITORY https://github.com/catchorg/Catch2.git
	GIT_TAG v3.8.0
	EXCLUDE_FROM_ALL YES)

add_executable(unit-test-dssp ${CMAKE_CURRENT_SOURCE_DIR}/unit-test-dssp.cpp ${PROJECT_SOURCE_DIR}/libdssp/src/dssp-io.cpp)

target_include_directories(unit-test-dssp PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}/src
	${CMAKE_CURRENT_SOURCE_DIR}/include
)

target_link_libraries(unit-test-dssp PRIVATE dssp cifpp::cifpp Catch2::Catch2)

if(MSVC)
	# Specify unwind semantics so that MSVC knowns how to handle exceptions
	target_compile_options(unit-test-dssp PRIVATE /EHsc)
endif()

add_test(NAME unit-test-dssp COMMAND $<TARGET_FILE:unit-test-dssp>
	--data-dir ${CMAKE_CURRENT_SOURCE_DIR}
	--rsrc-dir ${CMAKE_CURRENT_SOURCE_DIR}/../libdssp/mmcif_pdbx/)

if(BUILD_PYTHON_MODULE)
	find_package(Python REQUIRED Interpreter)

	add_test(NAME python_module COMMAND ${Python_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/test-python.py")
	set_tests_properties(python_module PROPERTIES
		ENVIRONMENT "PYTHONPATH=$<TARGET_FILE_DIR:mkdssp_module>"
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
endif()

=== debian/changelog ===
dssp (4.5.5-1) unstable; urgency=medium

  * New upstream version 4.5.5
  * temporary fix for building in Debian
  * Closes: #1106880

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 31 Aug 2025 13:19:12 +0200

=== debian/control ===
Source: dssp
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
 cmake,
 mrc,
 libcifpp-dev (>= 5.0.7.1-1~),
 libboost-dev,
 libboost-regex-dev,
 zlib1g-dev,
 catch2,
 libmcfp-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/med-team/dssp
Vcs-Git: https://salsa.debian.org/med-team/dssp.git
Homepage: https://github.com/PDB-REDO/dssp

Package: dssp
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: protein secondary structure assignment based on 3D structure
 DSSP is an application you use to assign the secondary structure of a protein
 based on its solved three dimensional (3D) structure.
 .
 This version (4.2) of DSSP is a rewrite that writes annotated mmCIF files
 by default but can still produce the older dssp format. New is also the
 support of PP helices.

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/dssp-$1\.tar\.gz/ \
  https://github.com/PDB-REDO/dssp/tags .*/v?(\d\S+)\.tar\.gz

## dssp 4.5.6

=== debian/changelog ===
dssp (4.5.6-1) unstable; urgency=medium

  * Update debian/salsa-ci.yml file
  * New upstream version 4.5.6

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 20 Nov 2025 09:09:03 +0100

## dssp 4.5.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,8 +24,10 @@
 
 cmake_minimum_required(VERSION 3.23)
 
-# set the project name
-project(mkdssp VERSION 4.5.5 LANGUAGES CXX)
+file(READ libdssp/VERSION VER_FILE_CONTENT)
+string(STRIP ${VER_FILE_CONTENT} VER_FILE_CONTENT)
+
+project(mkdssp VERSION ${VER_FILE_CONTENT} LANGUAGES CXX)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -124,13 +126,13 @@
 
 # CPMFindPackage does not pass on variables set with set_and_check
 # Working around this here
-find_package(cifpp 8.0.1 QUIET)
+find_package(cifpp 9 QUIET)
 
 if(NOT cifpp_FOUND)
 	CPMAddPackage(
 		NAME cifpp
 		GIT_REPOSITORY https://github.com/pdb-redo/libcifpp.git
-		GIT_TAG v8.0.1
+		GIT_TAG v9.0.0
 		EXCLUDE_FROM_ALL YES)
 endif()

=== libdssp/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,33 @@
-# Use the version of the parent list file, if any. May need a fix someday.
-if(NOT CMAKE_PARENT_LIST_FILE)
-	set(PROJECT_VERSION 4.5.2)
-endif()
+# SPDX-License-Identifier: BSD-2-Clause
+# 
+# Copyright (c) 2025 NKI/AVL, Netherlands Cancer Institute
+# 
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+# 
+# 1. Redistributions of source code must retain the above copyright notice, this
+#    list of conditions and the following disclaimer
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+# 
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
-project(libdssp VERSION ${PROJECT_VERSION})
+cmake_minimum_required(VERSION 3.23)
+
+file(READ VERSION VER_FILE_CONTENT)
+string(STRIP ${VER_FILE_CONTENT} VER_FILE_CONTENT)
+
+project(libdssp VERSION ${VER_FILE_CONTENT} LANGUAGES CXX)
 
 include(CMakePackageConfigHelpers)

=== debian/changelog ===
dssp (4.5.7-1) unstable; urgency=medium

  * New upstream version 4.5.7
  * Closes: #1121383

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 26 Nov 2025 10:56:41 +0100

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,10 @@
 Build-Depends: debhelper-compat (= 13),
  cmake,
  mrc,
- libcifpp-dev (>= 5.0.7.1-1~),
- libboost-dev,
- libboost-regex-dev,
- zlib1g-dev,
+ libcifpp-dev (>= 9),
  catch2,
  libmcfp-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/med-team/dssp
 Vcs-Git: https://salsa.debian.org/med-team/dssp.git
